#if defined(__linux__)
#if defined(__amd64__)

/*
 * Use Linux system call.
 */

#define SYS_exit         60
#define SYS_fork         57
#define SYS_wait4        61
#define SYS_kill         62
#define SYS_execve       59

#define SYS_read          0
#define SYS_write         1
#define SYS_open          2
#define SYS_close         3

#define SYS_dup          32
#define SYS_pipe         22
#define SYS_dup2         33
#define SYS_pipe2       293

#define SYS_sigaction    13 /* rt_sigaction */
#define SYS_sigprocmask  14 /* rt_sigprocmask */

#define SYS_chdir        80
#define SYS_ioctl        16
#define SYS_brk          12
#define SYS_getcwd       79

	.section .text

	.globl	___exit
	.type	___exit, @function
___exit:
	mov	$SYS_exit, %eax
	syscall
	retq

	.globl	__fork
	.type	__fork, @function
__fork:
	mov	$SYS_fork, %eax
	syscall
	retq

	.globl	__wait4
	.type	__wait4, @function
__wait4:
	mov	$SYS_wait4, %eax
	syscall
	retq

	.globl	__kill
	.type	__kill, @function
__kill:
	mov	$SYS_kill, %eax
	syscall
	retq

	.globl	__execve
	.type	__execve, @function
__execve:
	mov	$SYS_execve, %eax
	syscall
	retq

	.globl	__read
	.type	__read, @function
__read:
	mov	$SYS_read, %eax
	syscall
	retq

	.globl	__write
	.type	__write, @function
__write:
	mov	$SYS_write, %eax
	syscall
	retq

	.globl	__open
	.type	__open, @function
__open:
	mov	$SYS_open, %eax
	syscall
	retq

	.globl	__close
	.type	__close, @function
__close:
	mov	$SYS_close, %eax
	syscall
	retq

	.globl	__dup
	.type	__dup, @function
__dup:
	mov	$SYS_dup, %eax
	syscall
	retq

	.globl	__pipe
	.type	__pipe, @function
__pipe:
	mov	$SYS_pipe, %eax
	syscall
	retq

	.globl	__dup2
	.type	__dup2, @function
__dup2:
	mov	$SYS_dup2, %eax
	syscall
	retq

	.globl	__pipe2
	.type	__pipe2, @function
__pipe2:
	mov	$SYS_pipe2, %eax
	syscall
	retq

	.globl	__sigaction
	.type	__sigaction, @function
__sigaction:
	mov	$SYS_sigaction, %eax
	syscall
	retq

	.globl	__sigprocmask
	.type	__sigprocmask, @function
__sigprocmask:
	mov	$SYS_sigprocmask, %eax
	syscall
	retq

	.globl	__chdir
	.type	__chdir, @function
__chdir:
	mov	$SYS_chdir, %eax
	syscall
	retq

	.globl	__ioctl
	.type	__ioctl, @function
__ioctl:
	mov	$SYS_ioctl, %eax
	syscall
	retq

	.globl	__brk
	.type	__brk, @function
__brk:
	mov	$SYS_brk, %eax
	syscall
	retq

	.globl	____getcwd
	.type	____getcwd, @function
____getcwd:
	mov	$SYS_getcwd, %eax
	syscall
	retq
#endif
#endif
